package com.jz.sms.dmHub.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.jz.sms.dmHub.config.DmHubConfig;
import com.jz.sms.dmHub.service.DmHubService;
import com.jz.sms.util.OkHttpUtil;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * Dm hub系统交互业务层
 */
@Service
public class DmHubServiceImpl implements DmHubService {


    @Override
    public String getToken() {
        String appid = DmHubConfig.applicationId;
        String secret = DmHubConfig.applicationKey;
        String tokenUrl = DmHubConfig.tokenUrl;
        String grantType = "client_credentials";

        Map<String, String> requestMap = new HashMap<>();
        requestMap.put("appid", appid);
        requestMap.put("secret", secret);
        requestMap.put("grant_type", grantType);
        String retStr = OkHttpUtil.get(tokenUrl, requestMap);
        JSONObject retJson = JSONObject.parseObject(retStr);
        String errorCode = retJson.getString("error_code");
        if ("0".equals(errorCode)) {
            String accessToken = retJson.getString("access_token");
            String expires = retJson.getString("expires_in");
            return accessToken;
        } else {
            return null;
        }
        // TODO 存redis,过期时间=expires-600（秒）


    }

    @Override
    public Map<String, Object> smsReport(Map<String, Object> accInfo) {
        return null;
    }
}
